//+------------------------------------------------------------------+
//|                                              close positions.mq4 |
//|                                   Copyright  2007, Serega Lykov |
//|                                       http://mtexperts.narod.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"
#property show_confirm

extern int MagicNumber_1=111;
extern int MagicNumber_2=222;
extern int MagicNumber_3=333;

//+------------------------------------------------------------------+
//| "close all positions with specific magicnumber at current symbol"|
//+------------------------------------------------------------------+
int start()
  {
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
         {
          int mn=OrderMagicNumber();
          if(mn==MagicNumber_1 || mn==MagicNumber_2 || mn==MagicNumber_3)
            {
             int dir=OrderType();
             if(dir==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);
             if(dir==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);
             if(dir>=2) OrderDelete(OrderTicket(),CLR_NONE);
            }
         }
      }
   return(0);
  }
//+------------------------------------------------------------------+